/* File: atobj-rreq.h	
 *   -- created on Wed Apr 30 1997 
 *  
 *  $Header: /usr/src/mash/repository/mash/mash-1/atobj/atobj-rreq.h,v 1.2 1997/05/13 05:04:19 tecklee Exp $
 *
 * Description:
 */

#ifndef ATOBJ_RREQ_H
#define ATOBJ_RREQ_H

#include "atobj-rcvr.h"
#include "session-srm.h"

class AtobjRcvr;

class Atobj_request : public SRM_Request {
public:
        Atobj_request(AtobjRcvr* pRcvr, const AnimationId& anmId)
                : SRM_Request(),
                  pRcvr_(pRcvr), numtimes_(0), anmId_(anmId) 
                {}
        ~Atobj_request() {}

        int fill_ADU(Byte* pb, int len);
        /*virtual from SRM_Request*/
        virtual int fill_ADU() {
                // REVIEW: get the len right!
                return fill_ADU(pb_->data+sizeof(srmhdr), SRM_MTU);        
        }

private:
        AtobjRcvr *pRcvr_;
        int numtimes_;
        AnimationId anmId_;
};


class Atobj_reply : public SRM_Reply {
public:
        Atobj_reply(AtobjRcvr* pRcvr, const AnimationId& anmId)
                : SRM_Reply(),
                pRcvr_(pRcvr), anmId_(anmId)  {}
        ~Atobj_reply() {}

        int fill_ADU(Byte* pb, int len);
        /*virtual from SRM_Request*/
        virtual int fill_ADU() {
                // REVIEW: get the len right!
                return fill_ADU(pb_->data+sizeof(srmhdr), SRM_MTU);        
        }

private:
        AtobjRcvr *pRcvr_;
        AnimationId anmId_;     // need this for receiver to call up the right
                                // datasrc...
};

#endif /* #ifdef ATOBJ_RREQ_H */ 
