
#include <sys/param.h>
#include <netinet/in.h>
#include "jpeg.h"

static YUVJpegDecoder* decoder;
extern void JVideoConfig(JpegDecoder::config& c, int w, int h, int q);

static DiffJpegDecoder* diffdecoder;

extern "C" {
#include "nv/video.h"

void jpeg_decode(vidimage_t *image, u_char *data, int len)
{
	u_short *hdr = (u_short*)data;
	int width = ntohs(hdr[0]);
	int height = ntohs(hdr[1]);
	int qFactor = ntohs(hdr[2]);
	data += 8;
	len -= 8;
	if (decoder == 0) {
		JpegDecoder::config config;
		JVideoConfig(config, width, height, qFactor);
		decoder = new YUVJpegDecoder(config);
	}
	/*XXX hope there is room */
	data[len++] = 0xff;
	data[len++] = 0xd9; /* EOI */

	decoder->decode(data, len);

	u_short *syp = (u_short*)decoder->yplane();
	u_char *sup = decoder->uplane();
	u_char *svp = decoder->vplane();

	u_short *yp = (u_short*)image->y_data;
	u_char *uvp = (u_char*)image->uv_data;
	for (len = width * height; len >= 0; len -= 2) {
		*yp++ = *syp++;
		*uvp++ = *sup++ - 128;
		*uvp++ = *svp++ - 128;
	}
	VidImage_UpdateRect(image, 0, 0, width, height);
}

struct blkcache* init_jpegdiff(int w, int h, int q)
{
	JpegDecoder::config config;
	/*XXX*/
	JVideoConfig(config, w, h, q);
	diffdecoder = new DiffJpegDecoder(config);
	return (diffdecoder->dcts);
}

void jpeg_getdiff(u_char* in, int len, struct blkcache* bc, u_char* diffvector)
{
	diffdecoder->decode(in, len, bc, diffvector);
}

}
