#ifndef srmv2_manager_h
#define srmv2_manager_h

#include "tclcl.h"
#include "inet.h"
#include "srmv2.h"
#include "session-srmv2.h"
#include "pktbuf-srmv2.h"

class SRMv2_Source;
class SRMv2_Manager : public TclObject {
public:
	SRMv2_Manager() : TclObject(), session_(0) { }
	~SRMv2_Manager() { }
	int command(int argc, const char*const* argv);

	virtual void handle_data(SRMv2_Source *src, pktbuf *pb, unsigned int cid,
				 int seqno, unsigned char type, u_int32_t off,
				 int more);
	virtual void handle_rreq(SRMv2_Source *src, u_int32_t ss, u_int32_t es, 
				 unsigned int sbytes, unsigned int ebytes,
				 unsigned int cid);
	void handle_announce(SRMv2_Source *src, unsigned int cid, unsigned int signature, 
			     unsigned int ebytes);
	void handle_nsrepair(SRMv2_Source *src, srmv2_announcehdr *hdrs, int count);
	adubuf* reada(SRMv2_Source* src, unsigned int cid, unsigned int seqno);
	void prepare_to_send(SRMv2_Source* src, unsigned int cid, unsigned int seqno, 
			     unsigned int ss, unsigned int es);
protected:
	SRMv2_Session *session_;
};
#endif



