#
# Copyright (c) 1997 Regents of the University of California.
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. All advertising materials mentioning features or use of this software
#    must display the following acknowledgement:
# 	This product includes software developed by the MASH Research
# 	Group at the University of California Berkeley.
# 4. Neither the name of the University nor of the Research Group may be
#    used to endorse or promote products derived from this software without
#    specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# @(#) $Header: /usr/src/mash/repository/mash/mash-1/tcl/mc/main.tcl,v 1.12 1998/05/05 01:54:58 kwright Exp $
#

Import enable
import Log MCApp WebProxy Observer MBDebugDlg 

Class URL_Dumper -superclass Observer

URL_Dumper public init file {
	$self instvar file_
	set file_ [open $file w]
}

URL_Dumper public trace_url url {
	set url [string trim $url]
	set len [string length $url]
	if { [string last / $url] == [expr $len - 1] ||
		[string last ".html" $url] == [expr $len - 5] } {
		puts stderr "DUMP $url"
		puts $file_ "[clock seconds] $url"
		flush $file_

	}
}


# for tracing
global mctime
set mctime [new MCTime]

set app [new MCApp $argv]
set manager [eval $app getManager]
set webCastServer [new WebProxy 3234 $manager]
#set debugDlg [new MBDebugDlg $manager 1]
#$debugDlg change_state 1

#
# attach url tracefile
#
#$webCastServer attach_observer [new URL_Dumper webtrace]

vwait forever



